<template>
  <ObForm
    @submit="onSubmit"
    :form-data="formData"
    :form-model="formModel"
    :is-show-controls="isLoaded"
    :is-submit-disabled="submitButtonState"
    ok-text="Добавить"
    cancel-text="Отменить"
  >
    <ObLoader
      v-if="!isLoaded"
      class="modal-loader"
    />

    <template v-else-if="formData.props">
      <OwnerField @input="changeOwner" />

      <ObSelect
        :required="true"
        :is-search="true"
        :items="countries"
        :is-auto-complete="false"
        v-model="formData.countryCode"
        label="Страна регистрации водителя"
        class="bottom-20"
        value-exp="countryCode"
        display-exp="titleWording"
      />

      <ObCheckbox
        label="Свободный формат номера телефона"
        :value="!formData.props.is_phone_rus"
        @change="changePhoneFormat"
      />

      <!-- Reset icons for phones, because icon is too big for those small fields -->

      <div class="bottom-30">
        <div class="row top-10">
          <div class="col-xs-4">
            <ObInput
              label="Телефон"
              :mask="formData.props.is_phone_rus ? '+7 (999) 999-99-99' : ''"
              v-model="formData.props.phone"
              property="props.phone"
              :required="true"
              icon="none"
              @input="checkPhoneFormat($event, 'phone')"
            />
          </div>

          <div class="col-xs-4">
            <ObInput
              label="Доп. телефон"
              :mask="formData.props.is_phone_rus ? '+7 (999) 999-99-99' : ''"
              label-info="Укажите второй телефон, на случай если не получится связаться с вами по основному телефону"
              v-model="formData.props.phone_additional"
              property="props.phone_additional"
              popper-class="driver-add-form-tooltip"
              icon="none"
              @input="checkPhoneFormat($event, 'phone_additional')"
            />
          </div>

          <div class="col-xs-4">
            <ObInput
              label="Телефон диспетчера"
              :mask="formData.props.is_phone_rus ? '+7 (999) 999-99-99' : ''"
              v-model="formData.props.dispatcher_phone"
              property="props.dispatcher_phone"
              icon="none"
              @input="checkPhoneFormat($event, 'dispatcher_phone')"
            />
          </div>
        </div>
      </div>

      <ObCheckbox
        label="C правом самоназначения на рейс"
        v-model="formData.props.trip_access"
        class="bottom-30"
      />

      <h3 class="subtitle">
        Паспортные данные <span class="-light-raspberry-red">*</span>
      </h3>

      <ObCheckbox
        label="Паспорт РФ"
        v-model="formData.props.russian_passport"
        class="bottom-20"
      />

      <div class="row">
        <div class="col-xs-4">
          <ObInput
            label="Серия и номер"
            property="props.passport_num"
            :required="true"
            :mask="formData.props.russian_passport ? '9999 999999' : ''"
            v-model="formData.props.passport_num"
          />
        </div>

        <div class="col-xs-4">
          <ObDatePicker
            label="Дата выдачи"
            v-model="formData.props.passport_date"
            :required="true"
          />
        </div>

        <div class="col-xs-4">
          <ObDatePicker
            label="Дата рождения"
            v-model="formData.props.birthdate"
            :required="true"
          />
        </div>
      </div>

      <div class="bottom-30">
        <div class="row">
          <div class="col-xs-4">
            <ObInput
              label="Фамилия"
              :required="true"
              v-model="formData.props.lastname"
              property="props.lastname"
              placeholder="Фамилия"
            />
          </div>

          <div class="col-xs-4">
            <ObInput
              label="Имя"
              :required="true"
              v-model="formData.props.firstname"
              property="props.firstname"
              placeholder="Имя"
            />
          </div>

          <div class="col-xs-4">
            <ObInput
              label="Отчество"
              v-model="formData.props.middlename"
              placeholder="Если есть"
            />
          </div>
        </div>

        <ObInput
          v-model="formData.props.passport_issued_by"
          label="Кем выдан"
          placeholder="Укажите"
          property="props.passport_issued_by"
          :required="true"
        />
      </div>

      <h3 class="subtitle">Копии документов</h3>

      <div class="uploader-label">
        1.  Разворот паспорта с фотографией <span class="-light-raspberry-red">*</span>
      </div>

      <ObUploader
        :upload-method="uploadMethod"
        :upload-options="getUploadOptions()"
        :class="[ 'uploader', { 'hidden': isFileUploaded('PASSPORT') } ]"
        @process-start="onFilesProcessStart"
        @change="onUpload('PASSPORT', $event)"
      />

      <div class="uploader-label">
        2. Водительское удостоверение, обе стороны в одном файле на одной странице <span class="-light-raspberry-red">*</span>
      </div>

      <ObUploader
        :upload-method="uploadMethod"
        :upload-options="getUploadOptions()"
        :class="[ 'uploader', { 'hidden': isFileUploaded('DRIVERS') } ]"
        @process-start="onFilesProcessStart"
        @change="onUpload('DRIVERS', $event)"
      />

      <div class="uploader-label">
        3. Трудовой договор <span class="-light-raspberry-red">*</span>
      </div>

      <ObUploader
        :upload-method="uploadMethod"
        :upload-options="getUploadOptions()"
        :class="[ 'uploader', { 'hidden': isFileUploaded('EMPLOYMENT_CONTRACT') } ]"
        @process-start="onFilesProcessStart"
        @change="onUpload('EMPLOYMENT_CONTRACT', $event)"
      />

<!--      <div class="uploader-label uploader-label_last">-->
<!--        4. Дополнительные документы-->
<!--      </div>-->

<!--      <div class="text-description bottom-10">-->
<!--        Трудовые договора, разрешения на работу, трудовые характеристики, справки, отзывы и прочее-->
<!--      </div>-->

<!--      <ObUploader-->
<!--        @change="onUpload('other', $event)"-->
<!--        class="uploader"-->
<!--      />-->
    </template>
  </ObForm>
</template>

<script>
  import addFormMixin from './mixins/addFormMixin'
  import { required, requiredIf } from 'vuelidate/lib/validators'
  import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'

  export default {
    name: 'AddResourceDriver',
    mixins: [
      addFormMixin
    ],
    components: {
      ObDatePicker
    },
    data () {
      return {
        resourceName: 'Driver'
      }
    },
    computed: {
      formModel () {
        return {
          ownerUuid: {
            validator: {
              required: requiredIf(() => this.isModerator)
            }
          },
          countryCode: {
            value: 'rus',
            validator: {
              required
            }
          },
          props: {
            nested_fields: {
              is_phone_rus: {
                value: true
              },
              phone: {
                validator: {
                  required,
                  minLength: {
                    method: this.checkMinLength,
                    error: 'Некорректный номер телефона'
                  }
                }
              },
              phone_additional: {
                value: null,
                validator: {
                  minLength: {
                    method: this.checkMinLength,
                    error: 'Некорректный номер телефона'
                  }
                }
              },
              dispatcher_phone: {
                value: null,
                validator: {
                  minLength: {
                    method: this.checkMinLength,
                    error: 'Некорректный номер телефона'
                  }
                }
              },
              trip_access: {
                value: true
              },
              russian_passport: {
                value: true
              },
              passport_num: {
                validator: {
                  required
                }
              },
              passport_date: {
                validator: {
                  required
                }
              },
              birthdate: {
                validator: {
                  required
                }
              },
              firstname: {
                validator: {
                  required
                }
              },
              lastname: {
                validator: {
                  required
                }
              },
              middlename: {
                value: null
              },
              passport_issued_by: {
                validator: {
                  required
                }
              }
            }
          },
          links: {
            nested_fields: {
              PASSPORT: {
                value: [],
                validator: {
                  required
                }
              },
              DRIVERS: {
                value: [],
                validator: {
                  required
                }
              },
              EMPLOYMENT_CONTRACT: {
                value: [],
                validator: {
                  required
                }
              }
              // OTHER: {}
            }
          }
        }
      }
    },
    async mounted () {
      await this.getSpeciesUuid()

      this.isLoaded = true
    },
    methods: {
      changePhoneFormat () {
        // Using this instead of v-model, because
        // v-model can't contains negative condition (!is_phone_rus)
        this.formData.props.is_phone_rus = !this.formData.props.is_phone_rus
      },
      checkPhoneFormat (value, key) {
        // https://oboz.myjetbrains.com/youtrack/issue/SB-1439
        this.formData.props[key] = this.formData.props.is_phone_rus && value ? 7 + value : value || null
      },
      checkMinLength (value) {
        if (!this.formData.props.is_phone_rus) {
          return true
        }

        return value ? value.length >= 11 : true
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "./styles/addFormStyles";

  // To override .row
  .modal-body .top-10 {
    margin-top: 10px;
  }

  .uploader:not(:last-child) {
    margin-bottom: 20px;
  }

  .uploader-label_last {
    margin-bottom: 5px;
  }
</style>

<style>
  .driver-add-form-tooltip {
    max-width: 240px;
  }
</style>